REM xoroshiro32 ranking program

DECLARE SUB WRSTR (a$, b, c, d)

DIM a, b, c, d AS INTEGER
DIM pfreqmin, pfreqmax, pw as INTEGER
DIM zfreqmin, zfreqmax, zw as INTEGER
DIM nzfreqmin, nzfreqmax, nzw as INTEGER
DIM abcd.n, abcd.a, abcd.b, abcd.c, abcd.d AS INTEGER
DIM abcd.p, abcd.z, abcd.nz, abcd.r AS INTEGER
DIM abcd.count, abcd.dim AS INTEGER
DIM freq.n, freq.p1, freq.z1, freq.nz1 AS INTEGER
DIM freq.count, freq.dim AS INTEGER
DIM sort.n, sort.p1, sort.z1, sort.nz1 AS INTEGER
DIM sort.p, sort.z, sort.nz AS INTEGER
DIM sort.count, sort.dim AS INTEGER

DIM f(0 TO 255) AS LONG
DIM sumlong AS LONG
DIM rank AS LONG
DIM sum0, sum1, temp AS LONG

DIM actual, expected AS DOUBLE
DIM sum AS DOUBLE
DIM prank, zrank, nzrank AS DOUBLE

DIM file$, total$, tmp$
DIM pfield$(5), zfield$(5), nzfield$(5)

REM Sum weights
pw = 1: REM 2 to give pfreq twice the weight
zw = 1
nzw = 1

abcd.count = 84 * 16
freq.count = abcd.count
sort.count = abcd.count

abcd.n = 0: REM number of entry
abcd.a = 1: REM a constant
abcd.b = 2: REM b constant
abcd.c = 3: REM c constant
abcd.d = 4: REM d constant
abcd.p = 5: REM pfreq rank
abcd.z = 6: REM zfreq rank
abcd.nz = 7: REM nzfreq rank
abcd.r = 8: REM pfreq+zfreq+nzfreq rank

freq.n = 0: REM number of entry
freq.p1 = 1: REM pfreq total 1
freq.z1 = 2: REM zfreq total 1
freq.nz1 = 3: REM nzfreq total 1

sort.n = 0: REM number of entry
sort.p1 = 1: REM pfreq total 1 (0-12)
sort.z1 = 1: REM zfreq total 1 (1-21)
sort.nz1 = 1: REM nzfreq total 1 (1-45)
sort.p = 1: REM pfreq rank
sort.z = 2: REM zfreq rank
sort.nz = 3: REM nzfreq rank

abcd.dim = abcd.r
freq.dim = freq.nz1
sort.dim = sort.nz

DIM abcd(1 TO abcd.count, 0 TO abcd.dim) AS LONG
DIM freq(1 TO freq.count, 0 TO freq.dim) AS LONG
DIM sort(1 TO sort.count, 0 TO sort.dim) AS LONG

REM pfreq expected, to nearest non-zero integer
pfreqmin = 0
pfreqmax = 12
DIM pfreq$(pfreqmin TO pfreqmax)
pfreq$(0) = "1580030169"
pfreq$(1) = "1580030169"
pfreq$(2) = "790015084"
pfreq$(3) = "263338361"
pfreq$(4) = "65834590"
pfreq$(5) = "13166918"
pfreq$(6) = "2194486"
pfreq$(7) = "313498"
pfreq$(8) = "39187"
pfreq$(9) = "4354"
pfreq$(10) = "435"
pfreq$(11) = "40"
pfreq$(12) = "3"

REM zfreq expected, to nearest non-zero integer
zfreqmin = 1
zfreqmax = 21
DIM zfreq$(zfreqmin TO zfreqmax)
zfreq$(1) = "631342768"
zfreq$(2) = "232258025"
zfreq$(3) = "85442952"
zfreq$(4) = "31432706"
zfreq$(5) = "11563446"
zfreq$(6) = "4253954"
zfreq$(7) = "1564942"
zfreq$(8) = "575710"
zfreq$(9) = "211792"
zfreq$(10) = "77914"
zfreq$(11) = "28663"
zfreq$(12) = "10544"
zfreq$(13) = "3879"
zfreq$(14) = "1427"
zfreq$(15) = "525"
zfreq$(16) = "193"
zfreq$(17) = "71"
zfreq$(18) = "26"
zfreq$(19) = "10"
zfreq$(20) = "4"
zfreq$(21) = "1"

REM nzfreq expected, to nearest non-zero integer
nzfreqmin = 1
nzfreqmax = 45
DIM nzfreq$(nzfreqmin TO nzfreqmax)
nzfreq$(1) = "367426785"
nzfreq$(2) = "232258025"
nzfreq$(3) = "146815072"
nzfreq$(4) = "92804826"
nzfreq$(5) = "58663838"
nzfreq$(6) = "37082618"
nzfreq$(7) = "23440685"
nzfreq$(8) = "14817339"
nzfreq$(9) = "9366344"
nzfreq$(10) = "5920659"
nzfreq$(11) = "3742570"
nzfreq$(12) = "2365756"
nzfreq$(13) = "1495443"
nzfreq$(14) = "945300"
nzfreq$(15) = "597544"
nzfreq$(16) = "377720"
nzfreq$(17) = "238764"
nzfreq$(18) = "150928"
nzfreq$(19) = "95405"
nzfreq$(20) = "60307"
nzfreq$(21) = "38121"
nzfreq$(22) = "24097"
nzfreq$(23) = "15232"
nzfreq$(24) = "9629"
nzfreq$(25) = "6087"
nzfreq$(26) = "3847"
nzfreq$(27) = "2432"
nzfreq$(28) = "1537"
nzfreq$(29) = "972"
nzfreq$(30) = "614"
nzfreq$(31) = "388"
nzfreq$(32) = "245"
nzfreq$(33) = "155"
nzfreq$(34) = "98"
nzfreq$(35) = "62"
nzfreq$(36) = "39"
nzfreq$(37) = "25"
nzfreq$(38) = "16"
nzfreq$(39) = "10"
nzfreq$(40) = "6"
nzfreq$(41) = "4"
nzfreq$(42) = "3"
nzfreq$(43) = "2"
nzfreq$(44) = "1"
nzfreq$(45) = "1"

CLS

REM Directory paths
abcdir$ = "G:\"
bindir$ = "G:\TEMP\"
csvdir$ = "G:\"

REM ***** PFREQ *****

REM Read aabbcc.pb binary files and calculate Chi-Square sums

OPEN abcdir$ + "XORO32.ABC" FOR INPUT AS #3
OPEN csvdir$ + "XORO32P.CSV" FOR OUTPUT AS #2

PRINT #2, "# a,  b,  c,  d, Chi-Square 0-";
PRINT #2, LTRIM$(STR$(pfreqmax))
PRINT "Reading pfreq data and writing to " + csvdir$ + "XORO32P.CSV"

WHILE NOT EOF(3)
  REM Read next aabbcc
  LINE INPUT #3, file$
  a = VAL(LEFT$(file$, 2))
  b = VAL(MID$(file$, 3, 2))
  c = VAL(MID$(file$, 5, 2))
  OPEN bindir$ + file$ + ".PB" FOR BINARY ACCESS READ AS #1
  n = 1
  FOR d = 0 TO 15
    sum = 0
    CALL WRSTR(STR$(a), 3, 2, 1)
    CALL WRSTR(STR$(b), 3, 2, 1)
    CALL WRSTR(STR$(c), 3, 2, 1)
    CALL WRSTR(STR$(d), 3, 2, 1)
    REM Read all 32-bit frequency values but most not used
    FOR x = 0 TO 255
      GET #1, n, f(x)
      n = n + 4
    NEXT x
    FOR x = pfreqmin TO pfreqmax
      actual = f(x)
      IF actual < 0 THEN
        actual = actual + 4294967296#
      END IF
      REM Calculate Chi-Square = (Actual-Expected)^2/Expected
      REM (a-b)^2/b = a(a/b - 2) + b
      expected = VAL(pfreq$(x))
      sum = sum + ((actual / expected) - 2) * actual + expected
    NEXT x
    IF sum > 2147483647 THEN
      total$ = "2147483647"
    ELSE
      sumlong = sum
      total$ = LTRIM$(STR$(sumlong))
    END IF
    IF LEN(total$) < 11 THEN
      FOR x = 1 TO 11 - LEN(total$)
        total$ = " " + total$
      NEXT x
    END IF
    CALL WRSTR(total$, 16, 2, 0)
  NEXT d
  CLOSE #1
WEND

CLOSE #2
CLOSE #3

REM ***** ZFREQ *****

REM Read aabbcc.zb binary files and calculate Chi-Square sums

OPEN abcdir$ + "XORO32.ABC" FOR INPUT AS #3
OPEN csvdir$ + "XORO32Z.CSV" FOR OUTPUT AS #2

PRINT #2, "# a,  b,  c,  d, Chi-Square 1-";
PRINT #2, LTRIM$(STR$(zfreqmax))
PRINT "Reading zfreq data and writing to " + csvdir$ + "XORO32Z.CSV"

WHILE NOT EOF(3)
  LINE INPUT #3, file$
  a = VAL(LEFT$(file$, 2))
  b = VAL(MID$(file$, 3, 2))
  c = VAL(MID$(file$, 5, 2))
  OPEN bindir$ + file$ + ".ZB" FOR BINARY ACCESS READ AS #1
  n = 1
  FOR d = 0 TO 15
    sum = 0
    CALL WRSTR(STR$(a), 3, 2, 1)
    CALL WRSTR(STR$(b), 3, 2, 1)
    CALL WRSTR(STR$(c), 3, 2, 1)
    CALL WRSTR(STR$(d), 3, 2, 1)
    REM Read all 32-bit frequency values but most not used
    FOR x = 0 TO 255
      GET #1, n, f(x)
      n = n + 4
    NEXT x
    FOR x = zfreqmin TO zfreqmax
      actual = f(x)
      IF actual < 0 THEN
        actual = actual + 4294967296#
      END IF
      REM Calculate Chi-Square = (Actual-Expected)^2/Expected
      REM (a-b)^2/b = a(a/b - 2) + b
      expected = VAL(zfreq$(x))
      sum = sum + ((actual / expected) - 2) * actual + expected
    NEXT x
    IF sum > 2147483647 THEN
      total$ = "2147483647"
    ELSE
      sumlong = sum
      total$ = LTRIM$(STR$(sumlong))
    END IF
    IF LEN(total$) < 11 THEN
      FOR x = 1 TO 11 - LEN(total$)
        total$ = " " + total$
      NEXT x
    END IF
    CALL WRSTR(total$, 16, 2, 0)
  NEXT d
  CLOSE #1
WEND

CLOSE #2
CLOSE #3

REM ***** NZFREQ *****

REM Read aabbcc.nzb binary files and calculate Chi-Square sums

OPEN abcdir$ + "XORO32.ABC" FOR INPUT AS #3
OPEN csvdir$ + "XORO32NZ.CSV" FOR OUTPUT AS #2

PRINT #2, "# a,  b,  c,  d, Chi-Square 1-";
PRINT #2, LTRIM$(STR$(nzfreqmax))
PRINT "Reading nzfreq data and writing to " + csvdir$ + "XORO32NZ.CSV"

WHILE NOT EOF(3)
  LINE INPUT #3, file$
  a = VAL(LEFT$(file$, 2))
  b = VAL(MID$(file$, 3, 2))
  c = VAL(MID$(file$, 5, 2))
  OPEN bindir$ + file$ + ".NZB" FOR BINARY ACCESS READ AS #1
  n = 1
  FOR d = 0 TO 15
    sum = 0
    CALL WRSTR(STR$(a), 3, 2, 1)
    CALL WRSTR(STR$(b), 3, 2, 1)
    CALL WRSTR(STR$(c), 3, 2, 1)
    CALL WRSTR(STR$(d), 3, 2, 1)
    REM Read all 32-bit frequency values but most not used
    FOR x = 0 TO 255
      GET #1, n, f(x)
      n = n + 4
    NEXT x
    FOR x = nzfreqmin TO nzfreqmax
      actual = f(x)
      IF actual < 0 THEN
        actual = actual + 4294967296#
      END IF
      REM Calculate Chi-Square = (Actual-Expected)^2/Expected
      REM (a-b)^2/b = a(a/b - 2) + b
      expected = VAL(nzfreq$(x))
      sum = sum + ((actual / expected) - 2) * actual + expected
    NEXT x
    IF sum > 2147483647 THEN
      total$ = "2147483647"
    ELSE
      sumlong = sum
      total$ = LTRIM$(STR$(sumlong))
    END IF
    IF LEN(total$) < 11 THEN
      FOR x = 1 TO 11 - LEN(total$)
        total$ = " " + total$
      NEXT x
    END IF
    CALL WRSTR(total$, 16, 2, 0)
  NEXT d
  CLOSE #1
WEND

CLOSE #2
CLOSE #3

REM ***** SORTING *****

OPEN csvdir$ + "XORO32P.CSV" FOR INPUT AS #1
OPEN csvdir$ + "XORO32Z.CSV" FOR INPUT AS #2
OPEN csvdir$ + "XORO32NZ.CSV" FOR INPUT AS #3
OPEN csvdir$ + "XORO32R.CSV" FOR OUTPUT AS #4

x = 0

DO
 
  FOR y = 1 TO 5
    INPUT #1, pfield$(y)
    INPUT #2, zfield$(y)
    INPUT #3, nzfield$(y)
    pfield$(y) = LTRIM$(RTRIM$(pfield$(y)))
    zfield$(y) = LTRIM$(RTRIM$(zfield$(y)))
    nzfield$(y) = LTRIM$(RTRIM$(nzfield$(y)))
  NEXT
 
  IF LEFT$(pfield$(1), 1) <> "#" THEN
   
    x = x + 1

    abcd(x, abcd.n) = x
    abcd(x, abcd.a) = VAL(pfield$(1))
    abcd(x, abcd.b) = VAL(pfield$(2))
    abcd(x, abcd.c) = VAL(pfield$(3))
    abcd(x, abcd.d) = VAL(pfield$(4))
    abcd(x, abcd.p) = x
    abcd(x, abcd.z) = x
    abcd(x, abcd.nz) = x
    abcd(x, abcd.r) = x

    freq(x, freq.n) = x
    freq(x, freq.p1) = VAL(pfield$(5))
    freq(x, freq.z1) = VAL(zfield$(5))
    freq(x, freq.nz1) = VAL(nzfield$(5))
 
  END IF

LOOP UNTIL x = abcd.count

REM ***** PFREQ *****

PRINT "Sorting pfreq data"

REM Copy pfreq to sort

FOR x = 1 TO freq.count
  sort(x, sort.n) = freq(x, freq.n)
  sort(x, sort.p1) = freq(x, freq.p1)
NEXT x

count = 0

DO
  change = 0
  FOR x = 1 TO sort.count - 1
    IF sort(x, sort.p1) > sort(x + 1, sort.p1) THEN
      REM Here if must swap
      FOR y = 0 TO sort.dim
        temp = sort(x, y)
        sort(x, y) = sort(x + 1, y)
        sort(x + 1, y) = temp
      NEXT y
      y = sort(x, pfreq.n)
      abcd(y, abcd.p) = x
      y = sort(x + 1, pfreq.n)
      abcd(y, abcd.p) = x + 1
      change = change + 1
      IF INKEY$ = CHR$(27) THEN STOP
    END IF
  NEXT x
  count = count + 1
  PRINT count, change
LOOP UNTIL change = 0

REM ***** ZFREQ *****

PRINT "Sorting zfreq data"

REM Copy zfreq to sort

FOR x = 1 TO freq.count
  sort(x, sort.n) = freq(x, freq.n)
  sort(x, sort.z1) = freq(x, freq.z1)
NEXT x

count = 0

DO
  change = 0
  FOR x = 1 TO sort.count - 1
    IF sort(x, sort.z1) > sort(x + 1, sort.z1) THEN
      REM Here if must swap
      FOR y = 0 TO sort.dim
        temp = sort(x, y)
        sort(x, y) = sort(x + 1, y)
        sort(x + 1, y) = temp
      NEXT y
      y = sort(x, pfreq.n)
      abcd(y, abcd.z) = x
      y = sort(x + 1, pfreq.n)
      abcd(y, abcd.z) = x + 1
      change = change + 1
      IF INKEY$ = CHR$(27) THEN STOP
    END IF
  NEXT x
  count = count + 1
  PRINT count, change
LOOP UNTIL change = 0

REM ***** NZFREQ *****

PRINT "Sorting nzfreq data"

REM Copy nzfreq to sort

FOR x = 1 TO freq.count
  sort(x, sort.n) = freq(x, freq.n)
  sort(x, sort.nz1) = freq(x, freq.nz1)
NEXT x

count = 0

DO
  change = 0
  FOR x = 1 TO sort.count - 1
    IF sort(x, sort.nz1) > sort(x + 1, sort.nz1) THEN
      REM Here if must swap
      FOR y = 0 TO sort.dim
        temp = sort(x, y)
        sort(x, y) = sort(x + 1, y)
        sort(x + 1, y) = temp
      NEXT y
      y = sort(x, pfreq.n)
      abcd(y, abcd.nz) = x
      y = sort(x + 1, pfreq.n)
      abcd(y, abcd.nz) = x + 1
      change = change + 1
      IF INKEY$ = CHR$(27) THEN STOP
    END IF
  NEXT x
  count = count + 1
  PRINT count, change
LOOP UNTIL change = 0

REM ***** PFREQ+ZFREQ+NZFREQ *****

PRINT "Sorting pfreq+zfreq+nzfreq data"

REM Generate combined pfreq+zfreq+nzfreq rankings

REM Copy abcd to sort

FOR x = 1 TO freq.count
  sort(x, sort.n) = abcd(x, abcd.n)
  sort(x, sort.p) = abcd(x, abcd.p)
  sort(x, sort.z) = abcd(x, abcd.z)
  sort(x, sort.nz) = abcd(x, abcd.nz)
  REM PRINT sort(x, 0), sort(x, 1), sort(x, 2)
NEXT x

count = 0

DO
  change = 0
  FOR x = 1 TO sort.count - 1
    sum0 = sort(x, sort.p) * pw + sort(x, sort.z) * zw + sort(x, sort.nz) * nzw
    sum1 = sort(x + 1, sort.p) * pw + sort(x + 1, sort.z) * zw + sort(x + 1, sort.nz) * nzw
    IF sum0 > sum1 OR sum0 = sum1 AND sort(x, sort.p) > sort(x + 1, sort.p) THEN
      REM Here if must swap
      FOR y = 0 TO sort.dim
        temp = sort(x, y)
        sort(x, y) = sort(x + 1, y)
        sort(x + 1, y) = temp
      NEXT y
      y = sort(x, pfreq.n)
      abcd(y, abcd.r) = x
      y = sort(x + 1, pfreq.n)
      abcd(y, abcd.r) = x + 1
      change = change + 1
      IF INKEY$ = CHR$(27) THEN STOP
    END IF
  NEXT x
  count = count + 1
  PRINT count, change
LOOP UNTIL change = 0

REM Now output sorted file

PRINT "Writing in numerical order to " + csvdir$ + "XORO32R.CSV"

REM Output in numerical [a,b,c,d] order

FOR x = 1 TO abcd.count

  FOR y = 1 TO abcd.dim
    tmp$ = LTRIM$(STR$(abcd(x, y)))
    IF y <= abcd.d THEN
      IF LEN(tmp$) = 1 THEN
        tmp$ = " " + tmp$
      END IF
    ELSE
      IF LEN(tmp$) < 4 THEN
        FOR z = 1 TO 4 - LEN(tmp$)
          tmp$ = " " + tmp$
        NEXT z
      END IF
    END IF
    PRINT #4, tmp$; ", ";
  NEXT y

  FOR y = 1 TO freq.nz1
    tmp$ = LTRIM$(STR$(freq(x, y)))
    IF LEN(tmp$) < 4 THEN
      FOR z = 1 TO 4 - LEN(tmp$)
        tmp$ = " " + tmp$
      NEXT z
    END IF
    IF y < freq.nz1 THEN
      PRINT #4, tmp$; ", ";
    ELSE
      PRINT #4, tmp$
    END IF
  NEXT y

NEXT x

PRINT #4, ""

PRINT "Writing in ranking order to " + csvdir$ + "XORO32R.CSV"

REM Output in ranking order

FOR x = 1 TO abcd.count

  n = sort(x, sort.n)

  FOR y = 1 TO abcd.dim
    tmp$ = LTRIM$(STR$(abcd(n, y)))
    IF y <= abcd.d THEN
      IF LEN(tmp$) = 1 THEN
        tmp$ = " " + tmp$
      END IF
    ELSE
      IF LEN(tmp$) < 4 THEN
        FOR z = 1 TO 4 - LEN(tmp$)
          tmp$ = " " + tmp$
        NEXT z
      END IF
    END IF
    PRINT #4, tmp$; ", ";
  NEXT y

  FOR y = 1 TO freq.nz1
    tmp$ = LTRIM$(STR$(freq(n, y)))
    IF LEN(tmp$) < 4 THEN
      FOR z = 1 TO 4 - LEN(tmp$)
        tmp$ = " " + tmp$
      NEXT z
    END IF
    IF y < freq.nz1 THEN
      PRINT #4, tmp$; ", ";
    ELSE
      PRINT #4, tmp$
    END IF
  NEXT y

NEXT x

CLOSE #1
CLOSE #2
CLOSE #3
CLOSE #4

END

SUB WRSTR (a$, b, c, d)
  DIM x$, PAD$, N
  x$ = LTRIM$(RTRIM$(a$))
  PAD$ = ""
  IF LEN(x$) < b THEN
    FOR n = 1 TO b - LEN(x$)
      PAD$ = PAD$ + " "
    NEXT N
  END IF
  x$ = PAD$ + x$
  IF d > 0 THEN
    x$ = x$ + ","
  ELSE
    x$ = x$ + CHR$(13) + CHR$(10)
  END IF
  IF c = 0 THEN
    PRINT x$;
  ELSE
    PRINT #c, x$;
  END IF
END SUB

